Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0007438OCamltypingpublic2016-12-21 16:062017-02-20 10:35
Reporteravsm 
Assigned Tofrisch 
PrioritynormalSeveritymajorReproducibilityalways
StatusresolvedResolutionfixed 
PlatformOSOS Version
Product Version4.04.0 
Target Version4.05.0 +dev/beta1/beta2/beta3/rc1Fixed in Version4.05.0 +dev/beta1/beta2/beta3/rc1 
Summary0007438: warning +34 exposes #row with private types
Description# #warnings "+34";;
# module type S = sig type t = private [> `Foo] end;;
module type S = sig type t = private [> `Foo ] end
# module type X = sig type t = private [> `Foo | `Bar] include S with type t := t end;;
Warning 34: unused type t#row.
module type X = sig type t = private [> `Bar | `Foo ] end

The "t#row" should not expose the row variable here, and the warning+34 shouldn't be triggered.
Additional InformationFound by Thomas Gazagnaire during https://github.com/mirage/mirage/pull/743 [^]
TagsNo tags attached.
Attached Files

- Relationships
related to 0006985closedgarrigue `module type of struct include Bar end` exposes %s#row when Bar contains private row types 

-  Notes
(0017294)
xleroy (administrator)
2017-02-16 15:46

@garrigue could you please have a look? Thanks!
(0017325)
garrigue (manager)
2017-02-18 09:19

Since this is an unused warning problem, I suppose Alain knows best what to do.
Namely, the warning shouldn't be triggered when the name of the type ends with "#row", but I'm not sure where it is best done.
Btype has utility functions is_row_name and is_constr_row to help.
(0017342)
xleroy (administrator)
2017-02-19 16:47

@frisch could you please have a look before 4.05 is released? Thank you.
(0017357)
frisch (developer)
2017-02-20 10:21

Looking at it.
(0017358)
frisch (developer)
2017-02-20 10:35

Fixed by 0855920c24c7ff16b6aefeb39368e11073e8d137 on trunk, cherry-picked as f29cadc33b4ac0581c955191c9c9d5d1e4bbd009 on 4.05.

- Issue History
Date Modified Username Field Change
2016-12-21 16:06 avsm New Issue
2017-02-16 15:44 xleroy Relationship added related to 0006985
2017-02-16 15:45 xleroy Note Added: 0017293
2017-02-16 15:45 xleroy Status new => acknowledged
2017-02-16 15:45 xleroy Note Deleted: 0017293
2017-02-16 15:46 xleroy Note Added: 0017294
2017-02-16 15:46 xleroy Assigned To => garrigue
2017-02-16 15:46 xleroy Status acknowledged => assigned
2017-02-18 09:15 garrigue Assigned To garrigue => frisch
2017-02-18 09:19 garrigue Note Added: 0017325
2017-02-19 16:47 xleroy Note Added: 0017342
2017-02-19 16:47 xleroy Target Version => 4.05.0 +dev/beta1/beta2/beta3/rc1
2017-02-20 10:21 frisch Note Added: 0017357
2017-02-20 10:35 frisch Note Added: 0017358
2017-02-20 10:35 frisch Status assigned => resolved
2017-02-20 10:35 frisch Fixed in Version => 4.05.0 +dev/beta1/beta2/beta3/rc1
2017-02-20 10:35 frisch Resolution open => fixed
2017-02-23 16:45 doligez Category OCaml typing => typing


Copyright © 2000 - 2011 MantisBT Group
Powered by Mantis Bugtracker